image: node
include:
  - template: License-Scanning.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: SAST.gitlab-ci.yml

cache:
  paths:
    - node_modules/

stages:
  - build
  - test
  - publish
  - deploy

build:
  stage: build
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  before_script:
    - npm ci
  script:
    - npm run build

unit-test:
  stage: test
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  script:
    - mkdir ./src/auth/keys && ssh-keygen -t rsa -f ./src/auth/keys/mein-wartezimmer -q -N ""
    - npm run test:cov


publish:
  image: docker:19.03.1
  stage: publish
  services:
    - docker:19.03.1-dind
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
    IMAGE_TAG: $CI_REGISTRY_IMAGE:latest
  allow_failure: false
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
  only:
    - master
  when: manual

production:
  stage: deploy
  image:
    name: bitnami/kubectl
    entrypoint: [""]
  environment:
    name: production
    url: "https://api.mein-wartezimmer.de"
  script:
    - echo "$K8S_CERTIFICATE" >> ca.pem
    - kubectl --server=$K8S_API_URL --token=$K8S_TOKEN --certificate-authority=ca.pem --namespace=orchard rollout restart deployment/mein-wartezimmer-backend
  only:
    - master
  when: manual

